unit VaxStealth;

interface
uses

    System.Classes,
    SysUtils,
    VaxCallSessionRoute,
    VaxServerCOM,
    VaxTeleServerSIP,
    VaxServerExCOM;


type TVaxStealth  = class

    private

    function IsStealthListnerCall(sDialNo : string): boolean;

    public
        m_objVaxServer : TVaxTeleServerSIP;

    public
       constructor Create(); reintroduce; overload;

    public
        function OnIncomingCall(nSessionId: Integer; sDialNo: String; nFromPeerType: Integer; sFromPeerName: String) : Boolean;
end;


implementation

    constructor TVaxStealth.Create();
    begin

    end;

      function TVaxStealth.IsStealthListnerCall(sDialNo : string): boolean;
      begin

        if(AnsiPos('#1#', sDialNo) <> 1) Then
          Exit(False);

        Result := True;

      end;

      function TVaxStealth.OnIncomingCall(nSessionId: Integer; sDialNo: String; nFromPeerType: Integer; sFromPeerName: String) : Boolean;
      begin

        if(IsStealthListnerCall(sDialNo) = False) Then Exit(False);

        sDialNo := StringReplace(sDialNo, '#1#', '', [rfReplaceAll, rfIgnoreCase]);
        Trim(sDialNo);

        TVaxServerExCOM.mVaxExCOM.AcceptCallSession(nSessionId, '', '', '', -1, '');
        TVaxServerExCOM.mVaxExCOM.AddStealthListener(nSessionId, TVaxServerCOM.VAX_PEER_TYPE_USER, sDialNo, TVaxServerCOM.VAX_CONF_ROOM_NORMAL_LISTENER);

        Result := True;

        end;
end.
