﻿Public Class cVaxSettingDefault

    Private m_objServerSIP As cVaxServerSIP

    Public Sub New(ByRef objVaxTeleSIP As cVaxServerSIP)
        m_objServerSIP = objVaxTeleSIP
    End Sub

    '/////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////

    Public Function LoadUserDefault() As Boolean

        Dim objStoreUser As cStoreUser = New cStoreUser()

        If (objStoreUser.IsDataStored() = True) Then
            Return False
        End If

        For nCount = 4040 To 4050
            m_objServerSIP.AddUser(nCount.ToString(), nCount.ToString(), "32014", False, "", "", -1, "", True)
        Next

        Return True

    End Function

    Public Function LoadQueueDefault() As Boolean

        Dim objStoreQueue As cStoreQueue = New cStoreQueue()

        If (objStoreQueue.IsDataStored() = True) Then
            Return False
        End If

        m_objServerSIP.AddQueue("Queue-Support", "Queue.wav", "DialTone.wav")
        m_objServerSIP.AddQueueAgent("Queue-Support", "4040")
        m_objServerSIP.SetQueueAgentPriority("Queue-Support", "4040", 0)
        m_objServerSIP.AddQueueAgent("Queue-Support", "4041")
        m_objServerSIP.SetQueueAgentPriority("Queue-Support", "4041", 1)
        m_objServerSIP.AddQueueAgent("Queue-Support", "4045")
        m_objServerSIP.SetQueueAgentPriority("Queue-Support", "4045", 2)
        m_objServerSIP.SetQueueProcessMode("Queue-Support", cVaxServerCOM.VAX_QUEUE_ALGO_ROUND_ROBIN, cVaxServerCOM.VAX_QUEUE_MODE_TYPE_FREE)

        m_objServerSIP.AddQueue("Queue-Technical", "Queue.wav", "DialTone.wav")
        m_objServerSIP.AddQueueAgent("Queue-Technical", "4042")
        m_objServerSIP.SetQueueAgentPriority("Queue-Technical", "4042", 0)
        m_objServerSIP.AddQueueAgent("Queue-Technical", "4043")
        m_objServerSIP.SetQueueAgentPriority("Queue-Technical", "4043", 1)
        m_objServerSIP.SetQueueProcessMode("Queue-Technical", cVaxServerCOM.VAX_RING_GROUP_ALGO_LEAST_ANSWERED, cVaxServerCOM.VAX_QUEUE_MODE_TYPE_FREE)

        Return True

    End Function

    Public Function LoadRingGroupDefault() As Boolean

        Dim objStoreRingGroup As cStoreRingGroup = New cStoreRingGroup()

        If (objStoreRingGroup.IsDataStored() = True) Then
            Return False
        End If

        m_objServerSIP.AddRingGroup("RingGroup-Team")
        m_objServerSIP.AddRingGroupAgent("RingGroup-Team", "4040")
        m_objServerSIP.SetRingGroupAgentPriority("RingGroup-Team", "4040", 0)
        m_objServerSIP.AddRingGroupAgent("RingGroup-Team", "4041")
        m_objServerSIP.SetRingGroupAgentPriority("RingGroup-Team", "4041", 1)
        m_objServerSIP.AddRingGroupAgent("RingGroup-Team", "4042")
        m_objServerSIP.SetRingGroupAgentPriority("RingGroup-Team", "4042", 2)
        m_objServerSIP.SetRingGroupProcessMode("RingGroup-Team", cVaxServerCOM.VAX_RING_GROUP_ALGO_RING_ALL, cVaxServerCOM.VAX_RING_GROUP_MODE_FREE)

        m_objServerSIP.AddRingGroup("RingGroup-Design")
        m_objServerSIP.AddRingGroupAgent("RingGroup-Design", "4040")
        m_objServerSIP.SetRingGroupAgentPriority("RingGroup-Design", "4040", 0)
        m_objServerSIP.AddRingGroupAgent("RingGroup-Design", "4041")
        m_objServerSIP.SetRingGroupAgentPriority("RingGroup-Design", "4041", 1)
        m_objServerSIP.AddRingGroupAgent("RingGroup-Design", "4042")
        m_objServerSIP.SetRingGroupAgentPriority("RingGroup-Design", "4042", 2)
        m_objServerSIP.SetRingGroupProcessMode("RingGroup-Design", cVaxServerCOM.VAX_RING_GROUP_ALGO_HUNT_RANDOM, cVaxServerCOM.VAX_RING_GROUP_MODE_FREE)

        Return True

    End Function

    Public Function LoadCallPickUpGroupDefault() As Boolean

        Dim objStorePickUpGroup As cStoreCallPickUp = New cStoreCallPickUp()

        If (objStorePickUpGroup.IsDataStored() = True) Then
            Return False
        End If

        m_objServerSIP.AddCallPickupGroup("PickupGroup-Accounts")

        m_objServerSIP.AddCallPickUpGroupMember("PickupGroup-Accounts", "4040")
        m_objServerSIP.AddCallPickUpGroupMember("PickupGroup-Accounts", "4041")
        m_objServerSIP.AddCallPickUpGroupMember("PickupGroup-Accounts", "4042")
        m_objServerSIP.AddCallPickUpGroupMember("PickupGroup-Accounts", "4043")
        m_objServerSIP.AddCallPickUpGroupMember("PickupGroup-Accounts", "4044")
        m_objServerSIP.AddCallPickUpGroupMember("PickupGroup-Accounts", "4045")

        Return True

    End Function

    Public Function LoadLineDefault() As Boolean

        Dim objStoreLine As cStoreLine = New cStoreLine()

        If (objStoreLine.IsDataStored() = True) Then
            Return False
        End If

        m_objServerSIP.AddLine("Line", "9090", "9090", "9090", "9090", "192.168.0.119", "192.168.0.119", "01234", false, -1, "", false, "", "", "Queue-Support")

        Return True

    End Function

    Public Function LoadRoomDefault() As Boolean

        Dim objStoreRoom As cStoreRoom = New cStoreRoom()

        If (objStoreRoom.IsDataStored() = True) Then
            Return False
        End If

        m_objServerSIP.AddRoom("Room-TechTalk", "8888")

        Return True

    End Function
       
End Class
