#include "stdafx.h"
#include "QueueAgentList.h"


//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////

CQueueAgentDetails::CQueueAgentDetails(LPCTSTR sAgentName)
{
	m_sAgentName = sAgentName;
}

CQueueAgentDetails::~CQueueAgentDetails(void)
{

}

/////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////

CQueueAgentList::CQueueAgentList(void)
{
	m_objAgentDetailsList.InitHashTable(100);
}

CQueueAgentList::~CQueueAgentList(void)
{
	DeleteAll();
}

/////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////

BOOL CQueueAgentList::AddAgent(LPCTSTR sAgentName)
{
	CQueueAgentDetails* pQueueAgentDetails = NULL;
	m_objAgentDetailsList.Lookup(sAgentName, pQueueAgentDetails);

	if(pQueueAgentDetails == NULL)
	{
		pQueueAgentDetails = new CQueueAgentDetails(sAgentName);
		m_objAgentDetailsList.SetAt(sAgentName, pQueueAgentDetails);
	}

	pQueueAgentDetails->m_sAgentName = sAgentName;
	return TRUE;
}

void CQueueAgentList::RemoveAgent(LPCTSTR sAgentName)
{
	CQueueAgentDetails* pQueueAgentDetails = NULL;

	m_objAgentDetailsList.Lookup(sAgentName, pQueueAgentDetails);
	if(pQueueAgentDetails == NULL) return;

	m_objAgentDetailsList.RemoveKey(sAgentName);
	delete pQueueAgentDetails;
}

BOOL CQueueAgentList::IsAgentExist(LPCTSTR sAgentName)
{
	CQueueAgentDetails* pQueueAgentDetails = NULL;

	m_objAgentDetailsList.Lookup(sAgentName, pQueueAgentDetails);
	if(pQueueAgentDetails == NULL) return FALSE;

	return TRUE;
}

CString CQueueAgentList::GetQueueAgentAt(int nIndex)
{
	if(nIndex >= m_objAgentDetailsList.GetCount())
		return "";

	CQueueAgentDetails* pQueueAgentDetails = NULL;

	POSITION posAgentList = m_objAgentDetailsList.GetStartPosition();
	
	for(int nAgentCount = 0; nAgentCount <= nIndex; nAgentCount++)
	{
		CString sAgentName;
		m_objAgentDetailsList.GetNextAssoc(posAgentList, sAgentName, pQueueAgentDetails);
	}

	return pQueueAgentDetails->m_sAgentName;
}

int CQueueAgentList::GetQueueAgentCount()
{
	return m_objAgentDetailsList.GetCount();
}

void CQueueAgentList::DeleteAll()
{
	POSITION posQueueList = m_objAgentDetailsList.GetStartPosition();
	
	CQueueAgentDetails* pQueueAgentDetails = NULL;
	CString sQueueAgentName;

	while(posQueueList != NULL)
	{
		m_objAgentDetailsList.GetNextAssoc(posQueueList, sQueueAgentName, pQueueAgentDetails);
		delete pQueueAgentDetails;
	}

	m_objAgentDetailsList.RemoveAll();
}