﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ServerSIP
{
    class cVaxCallSession
    {
        cVaxCall m_objVaxCall;
        cVaxTransfer m_objVaxTransfer;
        cVaxQueue m_objVaxQueue;
        cVaxRingGroup m_objVaxRingGroup;
        cVaxHold m_objVaxHold;
        cVaxDTMF m_objVaxDTMF;
        CVaxRecordPCM m_objVaxRecordPCM;
        cVaxDialTone m_objVaxDialTone;
        cVaxDetectedAMD m_objVaxDetectedAMD;
        cVaxCallParking m_objVaxCallParking;
        cVaxCallPickup m_objVaxCallPickup;
        cVaxStealthListen m_objVaxStealthListen;
        cVaxRoom m_objVaxRoom;

        Boolean m_bIsCallSessionAddedToRoom;
                
        public cVaxCallSession()
        {
           m_objVaxCall = new cVaxCall();
           m_objVaxTransfer = new cVaxTransfer();
           m_objVaxQueue = new cVaxQueue();
           m_objVaxRingGroup = new cVaxRingGroup();
           m_objVaxHold = new cVaxHold();
           m_objVaxDTMF = new cVaxDTMF();
           m_objVaxRecordPCM = new CVaxRecordPCM();
           m_objVaxDialTone = new cVaxDialTone();
           m_objVaxDetectedAMD = new cVaxDetectedAMD();

           m_objVaxCallParking = new cVaxCallParking();
           m_objVaxStealthListen = new cVaxStealthListen();
           m_objVaxCallPickup = new cVaxCallPickup();
           m_objVaxRoom = new cVaxRoom();
           
           m_bIsCallSessionAddedToRoom = false;
        }

        ~cVaxCallSession()
        {
        }
    
        #region Events

        ////////////////////////////////////////////////////////////////////////////////////////////
        ////////////////////////////////////  CVaxCall ////////////////////////////////////////////

        public void OnIncomingCall(int nSessionId, string sCallerName, string sCallerId, string sDialNo, string sRoomName, string sQueueName, string sRingGroupName, int nFromPeerType, string sFromPeerName, int nToPeerType, string sToPeerName, string sUserAgentName, string sFromIP, int nFromPort)
        {
            bool bProcessed = false;

            m_objVaxRoom.OnIncomingCall(nSessionId, sRoomName, ref bProcessed);

            if(bProcessed)
            {
                m_bIsCallSessionAddedToRoom = true;
                return;
            }

            m_objVaxQueue.OnIncomingCall(nSessionId, sCallerName, sCallerId, sQueueName, ref bProcessed); // Try to process as Queue call.

            if(bProcessed)
                return;

            m_objVaxRingGroup.OnIncomingCall(nSessionId, sCallerName, sCallerId, sRingGroupName, ref bProcessed); // Try to process as RingGroup call.

            if(bProcessed)
                return;

            m_objVaxCallParking.OnIncomingCall(nSessionId, sDialNo, nFromPeerType, ref bProcessed);     // Try to connect to Parked call.

            if(bProcessed)
                return;

            m_objVaxCallPickup.OnIncomingCall(nSessionId, sDialNo, nFromPeerType, sFromPeerName, ref bProcessed);  // A user wants to pickup other user/extention's call.

            if(bProcessed)
                return;

            m_objVaxStealthListen.OnIncomingCall(nSessionId, sDialNo, nFromPeerType, sFromPeerName, ref bProcessed); //Process for stealth-listening.

            if(bProcessed)
                return;

            m_objVaxCall.OnIncomingCall(nSessionId, sCallerName, sCallerId, sDialNo, nFromPeerType, sFromPeerName, nToPeerType, sToPeerName, ref bProcessed); // 'Process as normal call.

            if(!bProcessed)
                return;

        }

        public void OnCallSessionCreated(int nSessionId, int nReasonCode)
        {
            m_objVaxCall.OnCallSessionCreated(nSessionId, nReasonCode);
        }

        public void OnCallSessionConnecting(int nSessionId, int nChannelId, int nStatusCode, string sReasonPhrase)
        {
            m_objVaxCall.OnCallSessionConnecting(nSessionId, nChannelId, nStatusCode, sReasonPhrase);
        }

        public void OnCallSessionFailed(int nSessionId, int nChannelId, int nStatusCode, string sReasonPhrase)
        {
            m_objVaxCall.OnCallSessionFailed(nSessionId, nChannelId, nStatusCode, sReasonPhrase);
        }

        public void OnCallSessionConnected(int nSessionId)
        {
            if(m_bIsCallSessionAddedToRoom)
                m_objVaxRoom.OnCallSessionConnected(nSessionId);
            else
                m_objVaxCall.OnCallSessionConnected(nSessionId);
        }

        public void OnCallSessionClosed(int nSessionId, int nChannelId, int nReasonCode)
        {
            m_objVaxCall.OnCallSessionClosed(nSessionId, nChannelId, nReasonCode);
        }

        public void OnCallSessionLost(int nSessionId, int nChannelId)
        {
            m_objVaxCall.OnCallSessionLost(nSessionId, nChannelId);
        }

        public void OnCallSessionHangup(int nSessionId, int nChannelId)
        {
            m_objVaxCall.OnCallSessionHangup(nSessionId, nChannelId);
        }

        public void OnCallSessionTimeout(int nSessionId, int nChannelId)
        {
            m_objVaxCall.OnCallSessionTimeout(nSessionId, nChannelId);
        }

        public void OnCallSessionCancelled(int nSessionId)
        {
            m_objVaxCall.OnCallSessionCancelled(nSessionId);
        }

        public void OnCallSessionOpenCall(int nSessionId, int nChannelId, int nPeerType, string sPeerName)
        {
            m_objVaxCall.OnCallSessionOpenCall(nSessionId, nChannelId, nPeerType, sPeerName);
        } 

        public void OnCallSessionCloseCall(int nSessionId, int nChannelId, int nPeerType, string sPeerName)
        {
            m_objVaxCall.OnCallSessionCloseCall(nSessionId, nChannelId, nPeerType, sPeerName);
        }

        ////////////////////////////////////////////////////////////////////////////////////////////
        ////////////////////////////////////  CVaxHold  ////////////////////////////////////////

        public void OnCallSessionOnHold(int nSessionId, int nChannelId)
        {
            if(m_bIsCallSessionAddedToRoom)
                m_objVaxRoom.OnCallSessionOnHold(nSessionId, nChannelId);
            else
                m_objVaxHold.OnCallSessionOnHold(nSessionId, nChannelId);
        }

        public void OnCallSessionOffHold(int nSessionId, int nChannelId)
        {
            if(m_bIsCallSessionAddedToRoom)
                m_objVaxRoom.OnCallSessionOffHold(nSessionId, nChannelId);
            else
                m_objVaxHold.OnCallSessionOffHold(nSessionId, nChannelId);
        }

        ////////////////////////////////////////////////////////////////////////////////////////////
        ////////////////////////////////////  CVaxTransfer  ////////////////////////////////////////

        public void OnCallSessionTransferBlind(int nTransfererSessionId, int nTransfererChannelId, string sTransferer, string sTransferee, string sTransferTo)
        {
            if(m_bIsCallSessionAddedToRoom)
            {
                m_objVaxRoom.OnCallSessionTransferBlind(nTransfererSessionId, nTransfererChannelId, sTransferer, sTransferee, sTransferTo);
                return;
            }

            bool bProcessed = false;

            m_objVaxCallParking.OnCallSessionTransferBlind(nTransfererSessionId, nTransfererChannelId, sTransferer, sTransferee, sTransferTo, ref bProcessed);

            if(bProcessed)
                return;

            m_objVaxTransfer.OnCallSessionTransferBlind(nTransfererSessionId, nTransfererChannelId, sTransferer, sTransferee, sTransferTo);
        }

        public void OnCallSessionTransferConsult(int nTransfererSessionId, int nTransfererChannelId, int nTransferToSessionId, int nTransferToChannelId, string sTransferer, string sTransferee, string sTransferTo)
        {
            if(m_bIsCallSessionAddedToRoom)
                m_objVaxRoom.OnCallSessionTransferConsult(nTransfererSessionId, nTransfererChannelId, nTransferToSessionId, nTransferToChannelId, sTransferer, sTransferee, sTransferTo);
            else
                m_objVaxTransfer.OnCallSessionTransferConsult(nTransfererSessionId,  nTransfererChannelId,  nTransferToSessionId, nTransferToChannelId, sTransferer, sTransferee, sTransferTo);
        }

        public void OnCallSessionTransfering(int nSessionId, int nTransferType, int nChannelId, int nStatusCode, string sReasonPhrase)
        {
            m_objVaxTransfer.OnCallSessionTransfering(nSessionId, nTransferType, nChannelId, nStatusCode, sReasonPhrase);
        }

        public void OnCallSessionTransferFailed(int nSessionId, int nTransferType, int nChannelId, int nStatusCode, string sReasonPhrase)
        {
            m_objVaxTransfer.OnCallSessionTransferFailed(nSessionId, nTransferType, nChannelId, nStatusCode, sReasonPhrase);
        }

        public void OnCallSessionTransferTimeout(int nSessionId, int nTransferType, int nChannelId)
        {
            m_objVaxTransfer.OnCallSessionTransferTimeout(nSessionId, nTransferType, nChannelId);
        }

        public void OnCallSessionTransfered(int nSessionId, int nTransferType)
        {
            m_objVaxTransfer.OnCallSessionTransfered(nSessionId, nTransferType);
        }

        ////////////////////////////////////////////////////////////////////////////////////////
        //////////////////////////////  CVaxDialTone ///////////////////////////////////////////

        public void OnCallSessionDialToneStart(int nSessionId, int nChannelId, int nWaveId)
        {
            m_objVaxDialTone.OnCallSessionDialToneStart(nSessionId, nChannelId, nWaveId);
        }

        public void OnCallSessionDialToneStop(int nSessionId, int nChannelId, int nWaveId)
        {
            m_objVaxDialTone.OnCallSessionDialToneStop(nSessionId, nChannelId, nWaveId);
        }

        public void OnCallSessionPlayWaveDone(int nSessionId, int nWaveId)
        {
        }

        ////////////////////////////////////////////////////////////////////////////////////////
        //////////////////////////////  CVaxDTMF //////////////////////////////////////////////

        public void OnDetectedDigitDTMF(int nSessionId, int nChannelId, string sDigitDTMF)
        {
            m_objVaxDTMF.OnDetectedDigitDTMF(nSessionId, nChannelId, sDigitDTMF);
        }

        ////////////////////////////////////////////////////////////////////////////////////////
        //////////////////////////////  CVaxAMD //////////////////////////////////////////////

        public void OnCallSessionDetectedAMD(int nSessionId, int nChannelId, bool bIsHuman)
        {
            m_objVaxDetectedAMD.OnCallSessionDetectedAMD(nSessionId, nChannelId, bIsHuman);
        }
        
        ////////////////////////////////////////////////////////////////////////////////////////
        //////////////////////////////  CVaxRecordPCM //////////////////////////////////////////

        public void OnCallSessionRecordedPCM(int nSessionId, Byte[] aDataPCM, int nSizePCM)
        {
            m_objVaxRecordPCM.OnCallSessionRecordedPCM(nSessionId, aDataPCM, nSizePCM);
        }

        public void OnAddCallSessionToQueueSuccess(string sQueueName, int nSessionId)
        {
            m_objVaxQueue.OnAddCallSessionToQueueSuccess(sQueueName, nSessionId);
        }

        public void OnAddCallSessionToQueueFailed(string sQueueName, int nSessionId)
        {
            m_objVaxQueue.OnAddCallSessionToQueueFailed(sQueueName, nSessionId);
        }

        public void OnQueuePlayWaveStart(int nEventType, string sQueueName, int nSessionId)
        {
            m_objVaxQueue.OnQueuePlayWaveStart(nEventType, sQueueName, nSessionId);
        }

        public void OnQueuePlayWaveStop(int nEventType, string sQueueName, int nSessionId)
        {
            m_objVaxQueue.OnQueuePlayWaveStop(nEventType, sQueueName, nSessionId);
        } 

        public void OnAddCallSessionToRingGroupSuccess(int nSessionId, string sRingGroupName)
        {
            m_objVaxRingGroup.OnAddCallSessionToRingGroupSuccess(nSessionId, sRingGroupName);
        }

        public void OnAddCallSessionToRingGroupFailed(int nSessionId, string sRingGroupName)
        {
            m_objVaxRingGroup.OnAddCallSessionToRingGroupFailed(nSessionId, sRingGroupName);
        }

        # endregion     
    }
}
