﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ServerSIP
{
    class cVaxSettingDefault
    {
        cVaxServerSIP m_objServerSIP;

        public cVaxSettingDefault(cVaxServerSIP objServerSIP)
        {
            m_objServerSIP = objServerSIP;
        }

        ~cVaxSettingDefault()
        {
        }

        /////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////

        public Boolean LoadUserDefault()
        {
            cStoreUser objStoreUser = new cStoreUser();

            if (objStoreUser.IsDataStored())
                return false;

            for (int nCount = 4040; nCount <= 4050; nCount++)
                m_objServerSIP.AddUser(nCount.ToString(), nCount.ToString(), "32014", false, "", "", -1, "", true);

            return true;
        }

        public Boolean LoadQueueDefault()
        {
            cStoreQueue objStoreQueue = new cStoreQueue();

            if (objStoreQueue.IsDataStored())
                return false;

            m_objServerSIP.AddQueue("Queue-Support", "Queue.wav", "DialTone.wav");
            m_objServerSIP.AddQueueAgent("Queue-Support", "4040");
            m_objServerSIP.SetQueueAgentPriority("Queue-Support", "4040", 0);
            m_objServerSIP.AddQueueAgent("Queue-Support", "4041");
            m_objServerSIP.SetQueueAgentPriority("Queue-Support", "4041", 1);
            m_objServerSIP.AddQueueAgent("Queue-Support", "4045");
            m_objServerSIP.SetQueueAgentPriority("Queue-Support", "4045", 2);
            m_objServerSIP.SetQueueProcessMode("Queue-Support", cVaxServerCOM.VAX_QUEUE_ALGO_ROUND_ROBIN, cVaxServerCOM.VAX_QUEUE_MODE_TYPE_FREE);

            m_objServerSIP.AddQueue("Queue-Technical", "Queue.wav", "DialTone.wav");
            m_objServerSIP.AddQueueAgent("Queue-Technical", "4042");
            m_objServerSIP.SetQueueAgentPriority("Queue-Technical", "4042", 0);
            m_objServerSIP.AddQueueAgent("Queue-Technical", "4043");
            m_objServerSIP.SetQueueAgentPriority("Queue-Technical", "4043", 1);
            m_objServerSIP.SetQueueProcessMode("Queue-Technical", cVaxServerCOM.VAX_RING_GROUP_ALGO_LEAST_ANSWERED, cVaxServerCOM.VAX_QUEUE_MODE_TYPE_FREE);

            return true;
        }

        public Boolean LoadRingGroupDefault()
        {
            cStoreRingGroup objStoreRingGroup = new cStoreRingGroup();

            if (objStoreRingGroup.IsDataStored())
                return false;

            m_objServerSIP.AddRingGroup("RingGroup-Team");
            m_objServerSIP.AddRingGroupAgent("RingGroup-Team", "4040");
            m_objServerSIP.SetRingGroupAgentPriority("RingGroup-Team", "4040", 0);
            m_objServerSIP.AddRingGroupAgent("RingGroup-Team", "4041");
            m_objServerSIP.SetRingGroupAgentPriority("RingGroup-Team", "4041", 1);
            m_objServerSIP.AddRingGroupAgent("RingGroup-Team", "4042");
            m_objServerSIP.SetRingGroupAgentPriority("RingGroup-Team", "4042", 2);
            m_objServerSIP.SetRingGroupProcessMode("RingGroup-Team", cVaxServerCOM.VAX_RING_GROUP_ALGO_RING_ALL, cVaxServerCOM.VAX_RING_GROUP_MODE_FREE);

            m_objServerSIP.AddRingGroup("RingGroup-Design");
            m_objServerSIP.AddRingGroupAgent("RingGroup-Design", "4040");
            m_objServerSIP.SetRingGroupAgentPriority("RingGroup-Design", "4040", 0);
            m_objServerSIP.AddRingGroupAgent("RingGroup-Design", "4041");
            m_objServerSIP.SetRingGroupAgentPriority("RingGroup-Design", "4041", 1);
            m_objServerSIP.AddRingGroupAgent("RingGroup-Design", "4042");
            m_objServerSIP.SetRingGroupAgentPriority("RingGroup-Design", "4042", 2);
            m_objServerSIP.SetRingGroupProcessMode("RingGroup-Design", cVaxServerCOM.VAX_RING_GROUP_ALGO_HUNT_RANDOM, cVaxServerCOM.VAX_RING_GROUP_MODE_FREE);

            return true;
        }

        public Boolean LoadCallPickUpGroupDefault()
        {
            cStoreCallPickUp objStorePickUpGroup = new cStoreCallPickUp();

            if (objStorePickUpGroup.IsDataStored())
                return false;

            m_objServerSIP.AddCallPickUpGroup("PickupGroup-Accounts");

            m_objServerSIP.AddCallPickUpGroupMember("PickupGroup-Accounts", "4040");
            m_objServerSIP.AddCallPickUpGroupMember("PickupGroup-Accounts", "4041");
            m_objServerSIP.AddCallPickUpGroupMember("PickupGroup-Accounts", "4042");
            m_objServerSIP.AddCallPickUpGroupMember("PickupGroup-Accounts", "4043");
            m_objServerSIP.AddCallPickUpGroupMember("PickupGroup-Accounts", "4044");
            m_objServerSIP.AddCallPickUpGroupMember("PickupGroup-Accounts", "4045");

            return true;
        }

        public Boolean LoadLineDefault()
        {
            cStoreLine objStoreLine = new cStoreLine();

            if (objStoreLine.IsDataStored())
                return false;

            m_objServerSIP.AddLine("Line", "9090", "9090", "9090", "9090", "192.168.0.119", "192.168.0.119", "01234", false, -1, "", false, "", "", "Queue-Support");
            return true;
        }

        public Boolean LoadRoomDefault()
        {
            cStoreRoom objStoreRoom = new cStoreRoom();

            if (objStoreRoom.IsDataStored())
                return false;

            m_objServerSIP.AddRoom("Room-TechTalk", "8888");
            return true;
        }

    }
}
