﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ServerSIP
{
    class cStoreRoom : cStoreRegistry
    {
        const string ROOM_ROOT_PATH = "Rooms\\";

        public cStoreRoom()
        {
        }

        ~cStoreRoom()
        {
        }

         public Boolean AddRoom(string sRoomName, string sRoomNo)
         {
             if(sRoomName.Length == 0)
                 return false;

             string sKeyPath = ROOM_ROOT_PATH + sRoomName;
             return base.SetTEXT(sKeyPath, "RoomNo", sRoomNo);
         }

         public Boolean GetRoom(string sRoomName, ref string sRoomNo)
         {
             if(sRoomName.Length == 0)
                 return false;

             string sKeyPath = ROOM_ROOT_PATH + sRoomName;
             return base.GetTEXT(sKeyPath, "RoomNo", ref sRoomNo);
         }

         public Boolean RemoveRoom(string sRoomName)
         {
             if(sRoomName.Length == 0)
                 return false;

             string sKeyPath = ROOM_ROOT_PATH + sRoomName;
             return base.DeleteSubKey(sKeyPath);
         }

         public Boolean GetRoomAll(ref List<string> objListRoomAll)
         {
             objListRoomAll.Clear();

             string sKeyPath = ROOM_ROOT_PATH;
             return base.EnumSubKeys(sKeyPath, ref objListRoomAll);
         }

         public bool IsDataStored()
         {
             return base.IsKeyExist(ROOM_ROOT_PATH);
         }
    }
}
