﻿Public Class cVaxCallSession

    Dim m_sRoomName As String
    Dim m_objServerExCOM As cVaxServerExCOM

    '//////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////

    Public Sub New(ByVal objServerExCOM As cVaxServerExCOM)
        m_objServerExCOM = objServerExCOM
    End Sub

    '//////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////

    Public Overloads Function AcceptCallSession(ByVal nSessionId As Integer, ByVal sCallerName As String, ByVal sCallerId As String, ByVal sDialNo As String, ByVal nToPeerType As Integer, ByVal sToPeerName As String) As Boolean

        Dim bResult As Boolean = m_objServerExCOM.AcceptCallSession(nSessionId, sCallerName, sCallerId, sDialNo, nToPeerType, sToPeerName, 20)

        If (Not bResult) Then
            m_objServerExCOM.RejectCallSession(nSessionId, 404, "Not Found")
            Return False
        End If

        Return True

    End Function

    '//////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////

    Public Sub OnIncomingCall(ByVal nSessionId As Integer, ByVal sCallerName As String, ByVal sCallerId As String, ByVal sDialNo As String, ByVal sRoomName As String, ByVal nFromPeerType As Integer, ByVal sFromPeerName As String, ByVal nToPeerType As Integer, ByVal sToPeerName As String, ByVal sFromIP As String, ByVal nFromPort As Integer)

        m_sRoomName = sRoomName

        '//////////////////////////////////////////////////////////////////////

        If (sRoomName.Length <> 0) Then
            AcceptCallSession(nSessionId, "", "", "", -1, "") '// Accept the incoming call and add to conference room in OnCallSessionConnected()
            Return
        End If

        '//////////////////////////////////////////////////////////////////////

        If (nToPeerType = cVaxServerCOM.VAX_PEER_TYPE_LINE) Then
            sCallerName = ""
            sCallerId = ""
            '// Let AcceptCallSession() use DisplayName & UserName values of LINE as CallerName & CallerId.
        End If

        '//////////////////////////////////////////////////////////////////////

        If (Not AcceptCallSession(nSessionId, sCallerName, sCallerId, sDialNo, nToPeerType, sToPeerName)) Then
            Return
        End If

        m_objServerExCOM.DialToneToCallSession(True, nSessionId)

    End Sub

    '//////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////

    Public Sub OnCallSessionConnected(ByVal nSessionId As Integer)

        If (m_sRoomName.Length <> 0) Then
            m_objServerExCOM.AddCallSessionToConferenceRoom(m_sRoomName, nSessionId, cVaxServerCOM.TYPE_VOICE_NORMAL)
            Return
        End If

    End Sub

    Public Sub OnCallSessionConnecting(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
        m_objServerExCOM.CallSessionSendStatusResponse(nSessionId, nStatusCode, sReasonPhrase, "")
    End Sub

    Public Sub OnCallSessionFailed(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
        m_objServerExCOM.CallSessionSendStatusResponse(nSessionId, nStatusCode, sReasonPhrase, "")
    End Sub

    '//////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////

    Public Sub OnCallSessionOnHold(ByVal nSessionId As Integer, ByVal nChannelId As Integer)

        If (m_sRoomName.Length <> 0) Then
            Return
        End If

        m_objServerExCOM.AcceptOnHoldRequest(nSessionId)

    End Sub

    Public Sub OnCallSessionOffHold(ByVal nSessionId As Integer, ByVal nChannelId As Integer)

        If (m_sRoomName.Length <> 0) Then
            Return
        End If

        m_objServerExCOM.AcceptOffHoldRequest(nSessionId)

    End Sub

    '//////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////

    Public Sub OnCallSessionTransferBlind(ByVal nTransfererSessionId As Integer, ByVal nTransfererChannelId As Integer, ByVal sTransferer As String, ByVal sTransferee As String, ByVal sTransferTo As String)

        If (m_sRoomName.Length <> 0) Then
            m_objServerExCOM.RejectTransfer(nTransfererSessionId)
            Return
        End If

        m_objServerExCOM.AcceptTransferBlind(nTransfererSessionId, sTransferee, sTransferee, sTransferTo, cVaxServerCOM.VAX_PEER_TYPE_USER, sTransferTo, 30)

    End Sub

    Public Sub OnCallSessionTransferConsult(ByVal nTransfererSessionId As Integer, ByVal nTransfererChannelId As Integer, ByVal nTransferToSessionId As Integer, ByVal nTransferToChannelId As Integer, ByVal sTransferer As String, ByVal sTransferee As String, ByVal sTransferTo As String)

        If (m_sRoomName.Length <> 0) Then
            m_objServerExCOM.RejectTransfer(nTransfererSessionId)
            Return
        End If

        m_objServerExCOM.AcceptTransferConsult(nTransfererSessionId, nTransferToSessionId)

    End Sub

    '//////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////

    Public Sub OnDetectedDigitDTMF(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal sDigitDTMF As String)
    End Sub

End Class
