#include "StdAfx.h"
#include "StoreDirectProxy.h"

#define SUB_KEY_BUFFER_SIZE	2000

#define ROOT_PATH	"DirectProxies\\"

CStoreDirectProxy::CStoreDirectProxy(void)
{
	
}

CStoreDirectProxy::~CStoreDirectProxy(void)
{

}

BOOL CStoreDirectProxy::AddDirectProxySIP(LPCTSTR sProxyName, LPCTSTR sAuthLogin, LPCTSTR sAuthPwd, LPCTSTR sDomainRealm, LPCTSTR sProxyIP, LONG lProxyPort, LPCTSTR sCodecList)
{
	CString sKeyPath;
	sKeyPath.Format("%s%s", ROOT_PATH, sProxyName);

     CStoreRegistry::SetTEXT(sKeyPath, "AuthLogin", sAuthLogin);
	 CStoreRegistry::SetTEXT(sKeyPath, "AuthPwd", sAuthPwd);
	 CStoreRegistry::SetTEXT(sKeyPath, "DomainRealm",  sDomainRealm);

	 CStoreRegistry::SetTEXT(sKeyPath, "ProxyIP", sProxyIP);
	 CStoreRegistry::SetTEXT(sKeyPath, "CodecList", sCodecList);

     CStoreRegistry::SetDWORD(sKeyPath, "ProxyPort", lProxyPort);
	 return TRUE;
}

BOOL CStoreDirectProxy::GetDirectyProxySIP(LPCTSTR sProxyName, CString& sAuthLogin, CString& sAuthPwd, CString& sDomainRealm, CString& sProxyIP, LONG& lProxyPort, CString& sCodecList )
{
	CString sKeyPath;
	sKeyPath.Format("%s%s", ROOT_PATH, sProxyName);

	CStoreRegistry::GetTEXT(sKeyPath, "AuthLogin", sAuthLogin);
	CStoreRegistry::GetTEXT(sKeyPath, "AuthPwd", sAuthPwd);
	CStoreRegistry::GetTEXT(sKeyPath, "DomainRealm",  sDomainRealm);

	CStoreRegistry::GetTEXT(sKeyPath, "ProxyIP", sProxyIP);
	CStoreRegistry::GetTEXT(sKeyPath, "CodecList", sCodecList);

	CStoreRegistry::GetDWORD(sKeyPath, "ProxyPort", (DWORD&)lProxyPort);	
	return TRUE;
}

void CStoreDirectProxy::RemoveDirectProxySIP(LPCTSTR sProxyName)
{
	CString sKeyPath;
	sKeyPath.Format("%s%s", ROOT_PATH, sProxyName);

    CStoreRegistry::DeleteSubKey(sKeyPath);
}

void CStoreDirectProxy::GetDirectProxyAll(CStringList* pDirectProxyList)
{
	CString sKeyPath;
	sKeyPath = ROOT_PATH;

	CStoreRegistry::EnumSubKeys(sKeyPath, pDirectProxyList);
}

BOOL CStoreDirectProxy::AddDirectProxyRoute(LPCTSTR sProxyName, int nToPeerType, LPCTSTR sToPeerName, BOOL bRejected, LPCTSTR sRoomName)
{
	CString sKeyPath;
	sKeyPath.Format("%s%s", ROOT_PATH, sProxyName);

	
	CStoreRegistry::SetTEXT(sKeyPath, "ToPeerName", sToPeerName);
	CStoreRegistry::SetTEXT(sKeyPath, "RoomName", sRoomName);

	CStoreRegistry::SetINT(sKeyPath, "ToPeerType", nToPeerType);
	CStoreRegistry::SetBOOL(sKeyPath, "Rejected", bRejected);
		
	return TRUE;
}

BOOL CStoreDirectProxy::GetDirectProxyRoute(LPCTSTR sProxyName, int& nToPeerType, CString&  sToPeerName, BOOL& bRejected, CString&  sRoomName)
{
	CString sKeyPath;
	sKeyPath.Format("%s%s", ROOT_PATH, sProxyName);

	CStoreRegistry::GetINT(sKeyPath, "ToPeerType", nToPeerType);
	CStoreRegistry::GetTEXT(sKeyPath, "ToPeerName", sToPeerName);

	CStoreRegistry::GetBOOL(sKeyPath, "Rejected", bRejected);
	CStoreRegistry::GetTEXT(sKeyPath, "RoomName", sRoomName);
		
	return TRUE;
}

void CStoreDirectProxy::RemoveDirectProxyRoute(LPCTSTR sProxyName)
{
	CString sKeyPath;
	sKeyPath.Format("%s%s", ROOT_PATH, sProxyName);

     CStoreRegistry::DeleteValue(sKeyPath, "ToPeerType");
     CStoreRegistry::DeleteValue(sKeyPath, "Rejected");

     CStoreRegistry::DeleteValue(sKeyPath, "ToPeerName");
     CStoreRegistry::DeleteValue(sKeyPath, "RoomName");

     CStoreRegistry::DeleteValue(sKeyPath, "QueueName");
     CStoreRegistry::DeleteValue(sKeyPath, "RingGroupName");

}

BOOL CStoreDirectProxy::IsDataStored()
{
   return CStoreRegistry::IsKeyExist(ROOT_PATH);
}
